#!/usr/bin/perl 
# nazwa pliku: dbi-insert.pl 
 
use strict; 
use warnings; 
use DBI; 
 
# Polacz sie z baza danych 
my $username = 'reuven'; 
my $password = ''; 
my $dbh = DBI->connect("DBI:Pg:dbname=coreperl", $username, $password, 
                       {'AutoCommit' => 1, 'PrintError' => 1}) || 
    die "Error connecting: '$DBI::errstr'"; 
 
# Jakie dane wstawiamy zapytaniem INSERT? 
my $first_name = 'Franklin'; 
my $last_name = 'Roosevelt'; 
my $address = '1600 Pennsylvania Avenue, Washington DC'; 
my $phone_number = '202-555-1234'; 
my $fax_number = '202-555-1235'; 
 
# Utworz zapytanie SQL  
my $sql = "INSERT INTO AddressBook "; 
$sql .= "(first_name, last_name, phone_number, address, fax_number) "; 
$sql .= "VALUES (?, ?, ?, ?, ?) "; 
 
# Przygotuj instrukcje 
my $sth = $dbh->prepare($sql) || 
    die "Error preparing: $DBI::errstr"; 
 
# Wykonaj instrukcje 
$sth->execute($first_name, $last_name, $phone_number, $address, $fax_number) || 
    die "Error executing: $DBI::errstr"; 
 
# Poinformuj o sukcesie 
print "Successfully inserted $first_name $last_name into AddressBook!\n"; 
 
# Zakoncz instrukcje 
$sth->finish; 
 
# Zakoncz polaczenie z baza danych 
$dbh->disconnect; 
